;******************************************************
;*  v^[i`rWOɂj                  *
;*    File-Name : PRINTER.ASM  /  1997.05.01          *
;* -------------------------------------------------- *
;*    v^['PRN_TBL'̃f[^󎚂         *
;*    󎚂 HALT ̂ŃZbg鎖        *
;******************************************************
;
CPU0	EQU	1		;TK-Z80=1
CPU1	EQU	0		;FX-Z80=1
;
;-----------------   EQUATION AREA   ------------------
 IF (CPU0)			;----- TK-Z80 ---------
PA	EQU	0F0h		;PIO-A
PB	EQU	PA+01h		;PIO-B
PC	EQU	PA+02h		;PIO-C
CWR	EQU	PA+03h		;Command
 ENDIF
 IF (CPU1)			;----- FX-Z80 ---------
PA	EQU	03Ah		;PIO-A Data
PAC	EQU	PA+01h		;      Command
PB	EQU	PA+02h		;PIO-B Data
PBC	EQU	PA+03h		;      Command
PC	EQU	PA+04h		;PIO-C Data
PCC	EQU	PA+05h		;      Command
 ENDIF
;
;---------- C[` ----------------------------
		ORG	8000h
		LD	SP,9800h
	IF (CPU1)
		LD	A,3Fh		;MMU̐ݒ
		OUT	(00h),A		; ROM:
		LD	A,00h		;  0000-7FFF
		OUT	(01h),A		; RAM:
		LD	A,3Fh		;  8000-FFFF
		OUT	(02h),A
		LD	A,00h
		OUT	(03h),A
		LD	A,3Fh
		OUT	(04h),A
		LD	A,00h
		OUT	(05h),A
		LD	A,1Fh
		OUT	(06h),A
		LD	A,00000000b	;ֳ  ò
		OUT	(1Dh),A		; PIOļ ֳ
	ENDIF
		CALL	INITPIO
		CALL	INITPRN
;----- Main -------------------------------------------
	IF (CPU0)
		CALL	PRN_ST
	ENDIF
		LD	BC,PRN_TBLE-PRN_TBL+1
		LD	IX,PRN_TBL
MAIN204:	LD	D,(IX)
		CALL	PRINTER
		JR	C,MAIN204
		DEC	BC
		LD	A,B
		OR	C
		JR	NZ,MAIN205
	IF (CPU0)
		CALL	PRN_END
	ENDIF
		HALT			;I
MAIN205:	INC	IX
		JR	MAIN204
;
;---------- P --------------------------------
PRINTER:	PUSH	BC
		IN	A,(PC)		;PE Check
		BIT	5,A
		JR	NZ,PRNTR02
		BIT	4,A		;FAULT Check
		JR	Z,PRNTR02
		BIT	7,A		;BUSY Check
		JR	NZ,PRNTR02
		LD	A,D		;Data Set
		OUT	(PB),A
		LD	A,0FEh		;STROBE Low
		OUT	(PC),A
		LD	A,0FFh		;STROBE High
		OUT	(PC),A
PRNTR01:	IN	A,(PC)		;ACKNLG Check
		BIT	6,A
		JR	NZ,PRNTR01
		POP	BC		;OK
		OR	A
		RET
PRNTR02:	POP	BC		;Error
		SCF
		RET
;
;---------- v^̏ --------------------------
INITPRN:	LD	A,0FDh		;INIT Low
		OUT	(PC),A
		CALL	TIMER00
		LD	A,0FFh		;INIT High
		OUT	(PC),A
		RET
;
TIMER00:
	IF (CPU0)
		LD	BC,4
	ENDIF
	IF (CPU1)
		LD	BC,4*4		;FX  TK  x4
	ENDIF
TIMER00_01:	DEC	BC
		LD	A,B
		OR	C
		JP	NZ,TIMER00_01
		RET
;
;---------- ohn̏ ----------------------------
INITPIO:
	IF (CPU0)
		LD	A,10001000b
		OUT	(CWR),A
	ENDIF
	IF (CPU1)
		LD	A,11111111b
		OUT	(PAC),A
		LD	A,11111111b
		OUT	(PBC),A
		LD	A,00001111b
		OUT	(PCC),A
	ENDIF
		RET
;
;---------- vg\ ----------------------------
PRN_ST:		LD	HL,PRN_ST_TBL
		LD	DE,0FFF8h
		LD	BC,8
		LDIR
		RET
PRN_ST_TBL:	DEFB	073h,050h,004h,054h
		DEFB	0F8h,080h,080h,080h
;
;---------- vgI\ --------------------------
PRN_END:	LD	HL,PRN_END_TBL
		LD	DE,0FFF8h
		LD	BC,8
		LDIR
		RET
PRN_END_TBL:	DEFB	073h,050h,004h,054h
		DEFB	0F8h,079h,054h,05Eh
;
;---------- vgf[^e[u --------------------
PRN_TBL:
	DEFB	'        +=========+                             ',0dh,0ah
	DEFB	'        | PRINTER |                             ',0dh,0ah
	DEFB	'        +====+====+                             ',0dh,0ah
	DEFB	'             |                                  ',0dh,0ah
	DEFB	'    +--------+--------+                         ',0dh,0ah
	DEFB	'    |  Register Save  |                         ',0dh,0ah
	DEFB	'    +--------+--------+                         ',0dh,0ah
	DEFB	'             |                                  ',0dh,0ah
	DEFB	'            .^.                                 ',0dh,0ah
	DEFB	'         .+`   `+. Yes                          ',0dh,0ah
	DEFB	'        <   PE ?  >------------------>+         ',0dh,0ah
	DEFB	'         `+.   .+`                    |         ',0dh,0ah
	DEFB	'            `v`                       |         ',0dh,0ah
	DEFB	'             |No                      |         ',0dh,0ah
	DEFB	'            .^.                       |         ',0dh,0ah
	DEFB	'         .+`   `+. Yes                |         ',0dh,0ah
	DEFB	'        < FAULT ? >------------------>|         ',0dh,0ah
	DEFB	'         `+.   ,+`                    |         ',0dh,0ah
	DEFB	'            `v`                       |         ',0dh,0ah
	DEFB	'             |No                      |         ',0dh,0ah
	DEFB	'            .^.                       |         ',0dh,0ah
	DEFB	'         .+`   `+. Yes                |         ',0dh,0ah
	DEFB	'        <  BUSY ? >------------------>|         ',0dh,0ah
	DEFB	'         `+.   .+`                    |         ',0dh,0ah
	DEFB	'            `v`                       |         ',0dh,0ah
	DEFB	'             |No                      |         ',0dh,0ah
	DEFB	'    +--------+--------+               |         ',0dh,0ah
	DEFB	'    |    Data Set     |               |         ',0dh,0ah
	DEFB	'    +--------+--------+               |         ',0dh,0ah
	DEFB	'             |                        |         ',0dh,0ah
	DEFB	'    +--------+--------+               |         ',0dh,0ah
	DEFB	'    |  STROBE = Low   |               |         ',0dh,0ah
	DEFB	'    +--------+--------+               |         ',0dh,0ah
	DEFB	'             |                        |         ',0dh,0ah
	DEFB	'    +--------+--------+               |         ',0dh,0ah
	DEFB	'    |  STROBE = High  |               |         ',0dh,0ah
	DEFB	'    +--------+--------+               |         ',0dh,0ah
	DEFB	'             |                        |         ',0dh,0ah
	DEFB	'+----------->|                        |         ',0dh,0ah
	DEFB	'|           .^.                       |         ',0dh,0ah
	DEFB	'|     No .+`   `+.                    |         ',0dh,0ah
	DEFB	'+-------< ACKNLG? >                   |         ',0dh,0ah
	DEFB	'         `+.   .+`                    |         ',0dh,0ah
	DEFB	'            `v`                       |         ',0dh,0ah
	DEFB	'             |Yes                     |         ',0dh,0ah
	DEFB	'    +--------+--------+      +--------+--------+',0dh,0ah
	DEFB	'    |  Register Load  |      |  Register Load  |',0dh,0ah
	DEFB	'    +--------+--------+      +--------+--------+',0dh,0ah
	DEFB	'             |                        |         ',0dh,0ah
	DEFB	'    +--------+--------+      +--------+--------+',0dh,0ah
	DEFB	'    | Carry Flag = 0  |      | Carry Flag = 1  |',0dh,0ah
	DEFB	'    +--------+--------+      +--------+--------+',0dh,0ah
	DEFB	'             |                        |         ',0dh,0ah
	DEFB	'        +====+====+              +====+====+    ',0dh,0ah
	DEFB	'        | RETURN  |              | RETURN  |    ',0dh,0ah
	DEFB	'        +=========+              +=========+    ',0dh,0ah
PRN_TBLE	EQU	$-1
;------------------------------------------------------
		END
