/******************************************************************************
*  v^  /  ʰ   : IF-UNIT No.4 & TK-Z80                            *
*                /  ߲ : LSIC-80(٥ ެ)                         *
*   ϼ݌꿰̧ : MACHINE.PSZ  /  C꿰̧ : PRINTER.C                   *
*      2̧ق߲/قAݸĎs\HEX̧ق쐬     *
* --------------------------------------------------------------------------- *
*   1̿ؽāAyѺ߲قʍ쐬ꂽؽĂ *
*   Aٰ͖߂ɂ͂̂CPUްނؾĂ邱                    *
******************************************************************************/
#include <z80.h>
#include <stdrom.h>

#define pio_a		0xf0
#define pio_b		pio_a+0x01
#define pio_c		pio_a+0x02
#define pio_cw		pio_a+0x03

void	init_pio();
void	init_prn();
char	printer();

extern	void led_disp(char);

static char table[];

/********** C ***********************************************************/
main()
{	char flag; short i;
	di();
	init_pio();
	init_prn();
	led_disp(0);
	i=0;
	while(table[i]!=0)
	{	do
		{	flag = printer(table[i]);}
		while(flag==0);
		i++;
	}
	led_disp(1);
	while(1);
}

/********** ohn *****************************************************/
void init_pio()
{	char d;
	d=0x88;outpz(pio_cw,d);
}

/********** v^ ***************************************************/
void init_prn()
{	char d,i;
	d=0xfc;outpz(pio_c,d);
	i=0; do {i++;} while(i<2);
	d=0xff;outpz(pio_c,d);
}

/********** P *******************************************************/
char printer(char c)
{	char a,d,flag;
	a=inpz(pio_c);
	if(((a&0x20)!=0)||
	   ((a&0x10)==0)||
	   ((a&0x80)!=0))
		flag=0;
	else
	{	outpz(pio_b,c);
		d=0xfe;outpz(pio_c,d);
		d=0xff;outpz(pio_c,d);
		while((inpz(pio_c)&0x40)!=0){}
		flag=1;
	}
	return flag;
}

/********** f[^e[u ***********************************************/
static char table[]="\
--------------------------------------------------------------------------\r\n\
\r\n\
                     TRANSLATION from C to ASSEMBLER\r\n\
                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\r\n\
                C Compiler  :  LSIC-80(LSI JAPAN CO.,LTD.)\r\n\
\r\n\
<-------------- C Language -------------->|<--------- Assembler --------->\r\n\
char printer(char c)                      |         PUSH    IX\r\n\
                                          |         LD      IX,0\r\n\
                                          |         ADD     IX,SP\r\n\
                                          |         PUSH    AF\r\n\
                                          |         LD      (MEMORY),IX\r\n\
                                          |         PUSH    BC\r\n\
                                          |         PUSH    BC\r\n\
{   char a,d,flag;                        |         LD      A,0F2h\r\n\
    a=inpz(pio_c);                        |         LD      C,A\r\n\
                                          |         IN      A,(C)\r\n\
                                          |         LD      (IX-4),A\r\n\
    if(((a&0x20)!=0)||                    |         BIT     5,(IX-4)\r\n\
       ((a&0x10)==0)||                    |         JR      NZ,__6\r\n\
       ((a&0x80)!=0))                     |         BIT     4,(IX-4)\r\n\
                                          |         JR      Z,__6\r\n\
                                          |         BIT     7,(IX-4)\r\n\
                                          |         JR      Z,__7\r\n\
                                          | __6:\r\n\
        flag=0;                           |         LD      (IX-6),0\r\n\
                                          |         JR      __8\r\n\
                                          | __7:\r\n\
    else                                  |         LD      E,(IX-1)\r\n\
    {   outpz(pio_b,c);                   |         LD      A,0F1h\r\n\
                                          |         LD      C,A\r\n\
                                          |         OUT     (C),E\r\n\
        d=0xfe;outpz(pio_c,d);            |         LD      (IX-5),0FEh\r\n\
                                          |         LD      E,(IX-5)\r\n\
                                          |         LD      A,0F2h\r\n\
                                          |         LD      C,A\r\n\
                                          |         OUT     (C),E\r\n\
        d=0xff;outpz(pio_c,d);            |         LD      (IX-5),0FFh\r\n\
                                          |         LD      E,(IX-5)\r\n\
                                          |         LD      A,0F2h\r\n\
                                          |         LD      C,A\r\n\
                                          |         OUT     (C),E\r\n\
        while((inpz(pio_c)&0x40)!=0){}    | __9:    LD      A,0F2h\r\n\
                                          |         LD      C,A\r\n\
                                          |         IN      A,(C)\r\n\
                                          |         BIT     6,A\r\n\
                                          |         JR      NZ,__9\r\n\
        flag=1;                           |         LD      (IX-6),1\r\n\
    }                                     |\r\n\
    return flag;                          | __8:    LD      A,(IX-6)\r\n\
                                          |         LD      SP,IX\r\n\
                                          |         POP     IX\r\n\
                                          |         LD      (MEMORY),IX\r\n\
                                          |         RET\r\n\
}                                         |\r\n\
                                          |\r\n\
------------------------------------------+-------------------------------\r\n\
";

